use32
  org 0x0
  db 'MENUET01' ;.    8 
  dd 0x1
  dd start
  dd i_end ;  
  dd mem
  dd stacktop
  dd 0x0
  dd cur_dir_path

include 'macros.inc'
include 'vectors.inc' ;vectors functions constant
include 'load_lib.mac'

@use_library

arr0c:
  .x dd 50.0
  .y dd 50.0
  .a dd 0.0 ;angle
  .s dd 1.0 ;scale
arr1c:
  .x dd 150.0
  .y dd 50.0
  .a dd 0.3 ;angle
  .s dd 1.0 ;scale
arr2c:
  .x dd 250.0
  .y dd 50.0
  .a dd 0.6 ;angle
  .s dd 1.0 ;scale
arr0v: ;A
  dw 2
  dd 20.0,50.0, 50.0,50.0
  dw 7
  dd 10.0,50.0, 10.0,80.0, 20.0,80.0, 20.0,60.0, 50.0,60.0, 50.0,80.0, 60.0,80.0
  dw 8+VECT_PARAM_PROP_L
  dd 4+VECT_CONT_BEZIER
  dd 10.0,50.0, 20.0,10.0, 60.0,10.0, 60.0,80.0
  dd 20.0,50.0, 30.0,20.0, 50.0,20.0, 50.0,50.0
  dw 0
arr1v: ;B
  dw 6+VECT_PARAM_PROP_L
  dd 2
  dd 10.0,10.0, 10.0,80.0, 20.0,20.0, 20.0,40.0, 20.0,50.0, 20.0,70.0
  dw 16+VECT_PARAM_PROP_L
  dd 4+VECT_CONT_BEZIER
  dd 10.0,10.0, 60.0,10.0, 60.0,40.0, 50.0,45.0
  dd 50.0,45.0, 60.0,50.0, 60.0,80.0, 10.0,80.0
  dd 20.0,20.0, 50.0,20.0, 50.0,40.0, 20.0,40.0
  dd 20.0,50.0, 50.0,50.0, 50.0,70.0, 20.0,70.0
  dw 0
arr2v: ;C
  dw 4+VECT_PARAM_PROP_L
  dd 2
  dd 50.0,30.0,60.0,30.0, 50.0,60.0,60.0,60.0
  dw 12+VECT_PARAM_PROP_L
  dd 6+VECT_CONT_BEZIER
  dd 60.0,30.0, 55.0,10.0, 10.0,10.0, 10.0,80.0, 55.0,80.0, 60.0,60.0
  dd 50.0,30.0, 45.0,20.0, 20.0,20.0, 20.0,70.0, 45.0,70.0, 50.0,60.0
  dw 0


align 4
start:
  mcall 48,3
  mcall 40,0x25

  sys_load_library vectors_name, cur_dir_path, library_path, system_path, \
    err_message_found_lib, head_f_l, vectors_lib_import, err_message_import, head_f_i

  push dword arr0v
  call [vect_conv_cont]
  push dword arr1v
  call [vect_conv_cont]
  push dword arr2v
  call [vect_conv_cont]


red_win:
  mcall 12,1

  xor eax,eax
  mov ebx,50*65536+320
  mov ecx,30*65536+250
  mov edx,0xffffff
  or  edx,0x33000000
  mov edi,hed
  mcall

  push dword 0xff
  push dword arr0v
  push dword arr0c
  call [vect_draw_cont]

  push dword 0xff00
  push dword arr1v
  push dword arr1c
  call [vect_draw_cont]

  push dword 0xff0000
  push dword arr2v
  push dword arr2c
  call [vect_draw_cont]

  mcall 12,2

still:
  mcall 10

  cmp al,0x1 ;.  
  jz red_win
  cmp al,0x3
  jz button
  jmp still


button:
;  mcall 17 ;   
;  cmp ah,1
;  jne still
.exit:
  mcall -1 ;  


o_dan dd ?
hed db 'Font in vector',0

;--------------------------------------------------
align 4
vectors_lib_import:
  vect_line dd av_line
  vect_c_bezier dd av_c_bezier
  vect_conv_cont dd av_conv_cont
  vect_draw_cont dd av_draw_cont
  vect_opred2i dd av_opred2i
  vect_line_len4i dd av_line_len4i
  vect_o_len dd av_o_len
  vect_o_ang dd av_o_ang

  dd 0,0
  av_line db 'vect_line',0
  av_c_bezier db 'vect_c_bezier',0
  av_conv_cont db 'vect_conv_cont',0
  av_draw_cont db 'vect_draw_cont',0
  av_opred2i db 'vect_opred2i',0
  av_line_len4i db 'vect_line_len4i',0
  av_o_len db 'vect_o_len',0
  av_o_ang db 'vect_o_ang',0

;--------------------------------------------------
system_path db '/sys/lib/'
vectors_name db 'vectors.obj',0
err_message_found_lib db 'Sorry I cannot load library vectors.obj',0
head_f_i:
head_f_l db 'System error',0
err_message_import db 'Error on load import library vectors.obj',0
;--------------------------------------------------

i_end: ; 
  rb 1024
stacktop:
  cur_dir_path:
    rb 4096
  library_path:
    rb 4096
mem:

